/*
 * yasapi_ring_plain.c
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2015-2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>

///////////////////////////////////////////////////////////////////////////////
static DWORD RingPlainConvertSizeSource(Ring *pRing, DWORD dwSize)
{
  return dwSize;
}

static DWORD RingPlainSizeSource(Ring *pRing)
{
  return RingPlainConvertSizeSource(pRing,pRing->_mp-pRing->_buf);
}

static DWORD RingPlainWrittenSource(Ring *pRing)
{
  return RingPlainConvertSizeSource(pRing,pRing->_dwWritten);
}

static DWORD RingPlainAvailableSource(Ring *pRing)
{
  return RingPlainConvertSizeSource(pRing,pRing->_dwAvailable);
}

////////////////
static DWORD RingPlainConvertSizeTarget(Ring *pRing, DWORD dwSize)
{
  return dwSize;
}

static DWORD RingPlainSizeTarget(Ring *pRing)
{
  return pRing->_mp-pRing->_buf;
}

static DWORD RingPlainWrittenTarget(Ring *pRing)
{
  return pRing->_dwWritten;
}

#if defined (YASAPI_TARGET_AVAILABLE) // [
static DWORD RingPlainAvailableTarget(Ring *pRing)
{
  return pRing->_dwAvailable;
}
#endif // ]

////////////////
static BYTE *RingPlainCopyToRing(Ring *pRing, BYTE *dst, const BYTE *src,
    DWORD dwSize)
{
  return memcpy(dst,src,dwSize);
}

static BYTE *RingPlainCopyFromRing(Ring *pRing, BYTE *dst, const BYTE *src,
    DWORD dwSize)
{
  return memcpy(dst,src,dwSize);
}

////////////////
IRingVtbl gcIRingPlainVtbl={
#if defined (YASAPI_SOURCE_CONVERT_SIZE) // [
  .source.ConvertSize=RingPlainConvertSizeSource,
#endif // ]
  .source.Size=RingPlainSizeSource,
  .source.Written=RingPlainWrittenSource,
  .source.Available=RingPlainAvailableSource,
  ////////////
  .target.ConvertSize=RingPlainConvertSizeTarget,
  .target.Size=RingPlainSizeTarget,
  .target.Written=RingPlainWrittenTarget,
#if defined (YASAPI_TARGET_AVAILABLE) // [
  .target.Available=RingPlainAvailableTarget,
#endif // ]
  ////////////
  .CopyToRing=RingPlainCopyToRing,
  .CopyFromRing=RingPlainCopyFromRing,
};
